function [ct,count] = pgm( OCP )
sigma=0.01;
beta=0.9;
res=10^-4;
yd=desiredState1(OCP);
u=0*ones((OCP.N-1)*OCP.Nt,1);
Jg(u,yd,OCP)
g=grad(u,yd,OCP);
count=0;
d=(OCP.b-OCP.a)*OCP.T/(OCP.N*OCP.Nt);
ctime=cputime;
res=inf;
while(res>OCP.res_conv)
    u_old=u;
%while(sqrt(sum((u-proj(u-g)).^2)*d)>OCP.res_conv)
    t=1;
    J_inte=Jg(u,yd,OCP);
     while(Jg(proj(u-t*g),yd,OCP)-J_inte>sigma*d*g'*(proj(u-t*g)-u))
         t=t*beta;
     end
    u=proj(u-t*g);
    g=grad(u,yd,OCP);
    count=count+1;
    res=sum((u-u_old).^2)*d;
end
ct=cputime-ctime;
f=zeros(OCP.Nt*(OCP.N+1),1);
y0=zeros((OCP.N+1),1);
y=implForward(u,y0,f,OCP);
[X,T]=meshgrid(OCP.a:(OCP.b-OCP.a)/OCP.N:OCP.b,0:OCP.T/OCP.Nt:OCP.T);
[Xu,Tu]=meshgrid((OCP.a+(OCP.b-OCP.a)/OCP.N):(OCP.b-OCP.a)/OCP.N:(OCP.b-(OCP.b-OCP.a)/OCP.N),0+OCP.T/OCP.Nt:OCP.T/OCP.Nt:OCP.T);
figure('Name','yg')
 mesh(X,T,reshape(y,[OCP.N+1,OCP.Nt+1])')
 xlabel('x');
 ylabel('t');
 figure('Name','ug')
 mesh(Xu,Tu,reshape(u,[OCP.N-1,OCP.Nt])')
 xlabel('x');
 ylabel('t');

J_last_gm=Jg(u,yd,OCP)
end

function [g]= grad(u,yd,OCP)
N=OCP.N;
Nt=OCP.Nt;
f=zeros(OCP.Nt*(OCP.N+1),1);
y0=zeros((OCP.N+1),1);

y=implForward(u,y0,f,OCP);
p=implBackward(y,yd, OCP);

for j=1:Nt
   g((j-1)*(N-1)+1:j*(N-1),1)=OCP.alpha*u((j-1)*(N-1)+1:j*(N-1),1)+OCP.beta+p((j-1)*(N+1)+2:j*(N+1)-1,1);
end

end

function [ u ] = proj( u)
u=min(max(0,u),10);
end

function [J]=Jg(u,yd,OCP)
J=0;
f=zeros(OCP.Nt*(OCP.N+1),1);
y0=zeros((OCP.N+1),1);
y=implForward(u,y0,f,OCP);
N=OCP.N;
Nt=OCP.Nt;
d=(OCP.b-OCP.a)*OCP.T/(N*Nt);
J=(0.5*d*transpose((y-yd))*(y-yd))+(0.5*OCP.alpha*d*(transpose(u)*u))+OCP.beta*d*sum(abs(u).*(abs(u)>OCP.s));
end