%Implementation of an NCG scheme to solve a random walk with jumps optimal control problem with absorbing boundary conditions
%implemented by Tim Breitenbach


function [  ] = optRWkonNCGe(  )
%hold on
counti_up=4;
for counti=4:counti_up
a=0;
b=1;
T=1;
D=1;
s=0.10;                      %s zulässig, das heißt 0<s<1-sum(g)
dt=T*(1/4)^(counti+1);
dx=sqrt(D*dt);
tol_t=10^-10;

% Int_dx=[20:10:110];
% Int_dt=[20:10:110].^2;
% dx=(b-a)/Int_dx(counti);
% dt=T/Int_dt(counti);

N=((b-a)/dx)-1
Nt=T/dt
x_initial_fd=(a+b)/2;    %für fd
ampl_sin_fd=(b-a)/2-0.15;      %für fd

Max1= (D/dx)*s;
Max2=(D/dx)*(2-s);
Maximi=min(Max1,Max2);
Min1=(-D/dx)*s;
Min2=-(D/dx)*(2-s);
Minimi=max(Min1,Min2);

f0=get_f0(dx, N,a,b);
% figure
% plot(a+dx:dx:b-dx,f0);
% title('f at n=0')

fd=get_fd(x_initial_fd, ampl_sin_fd, N, a, b, T,Nt,dx);
%fd=get_fd_test(N,Nt);
alpha=1;
beta=1;
gamma=0.1;
                    %für get_P
jc=0;
lambda=1;
[gp,gq,g0]=get_g(dx,0.1);

% jc=3;
% lambda=0.05;
% g0=0;
% gq(1)=0;
% gq(2)=1;
% gq(3)=1;
% 
% gp(1)=0;
% gp(2)=1;
% gp(3)=1;

                    %end für get_P

                    
u=Proj(0*ones(Nt,1),s,D,dx);                     %initial u
% u1=load('u5SQH.mat');
% u=u1.u;
% u=Proj(u,s,D,dx);
f=get_f(f0, s,D, gp, gq, lambda, jc, dx, dt, N, Nt, u);
g=gradJt(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, f, f0, fd, u);
ng0=sqrt(dt*g'*g)
grad_Jt=g;
d=-grad_Jt;
t=10^3;
res=inf;
i=0;
%full(get_P(s,D, gp, gq, lambda, jc, dx, dt, N, u(1)))
while(i<10000000)
    i=i+1;
    %u_vergleich=Proj(u-grad_Jt,s,D,dx);
    %res=sqrt((norm(u-u_vergleich)^2)*dt);
    res=sqrt(dt*norm(g)^2)
    t=get_WPS(alpha, beta, gamma, N, Nt, f, fd,f0,dx,dt,D,s,Maximi,Minimi,t,grad_Jt,u,d,gp, gq, lambda, jc,tol_t)
    if (res<10^-8 || t<tol_t)
        break;
    end
    %t=0.01;
    %t=armijo_Jt(alpha, beta, gamma, lambda, gp, gq,jc, dt, dx,s,D, N,Nt, f, f0, fd, u, grad_Jt)
    u=Proj(u+t*d,s,D,dx);
    f=get_f(f0, s,D, gp, gq, lambda, jc, dx, dt, N, Nt, u);
    g_alt=g;
    g=gradJt(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, f, f0, fd, u);
    grad_Jt=g;
    y=g-g_alt;
    sigma_HZ=y-2*d*(y')*y/(y'*d);
    beta_HZ=(sigma_HZ'*g)/(d'*y);
    d=-g+beta_HZ*d;
    %test_grad(alpha, beta, gamma, dx, dt, N, Nt,s,D, f0, fd,f,u,gp, gq, lambda, jc)
    %test_graduJ(alpha, beta, gamma, N, Nt,f0, fd,dt,dx,u)
    %test_gradfJ(alpha, beta, gamma, N,Nt,f,fd,f0,dt,dx,u)
end
dt*(gradJt(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, f, f0, fd, u)')*(0*ones(Nt,1)-u)
ng=sqrt(dt*norm(gradJt(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, f, f0, fd, u))^2)
f_check_sum=dx*sum(f((Nt-1)*N+1:Nt*N))
figure
plot(0:dt:T-dt,u)
xlabel('t');
save('u6.mat','u')
figure
[X,T]=meshgrid(a+dx:dx:b-dx,0:dt:T);
f_plot=[f0;f];
contour(X,T,reshape(f_plot,[N,Nt+1])',20);
xlabel('x');
ylabel('t');
% dt_interp=(T*(1/4)^(counti_up+1));
% u_interp(1:T/dt_interp,counti)=interp1(0:dt:(T-dt),u,0:dt_interp:T-dt_interp)';
% 
% plot(0:dt_interp:T-dt_interp,u_interp(:,counti));
% xlabel('t');

end
%hold off


% for n=1:counti_up-1
%     diff(n)=sqrt(T*(1/4)^(counti_up+1)*norm(u_interp(counti_up)-u_interp(n))^2)
% end
% Struc=fit(log(1./Int_dt(1:counti_up-1))',log(diff)','poly1');
% figure
% plot(log(1./Int_dt(1:counti_up-1))',log(diff)','x');
% hold on 
% plot(log(1./Int_dt(1:counti_up-1))',Struc.p2+Struc.p1*log(1./Int_dt(1:counti_up-1))')
% hold off
% Struc
end

function [grad]=gradJt(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, f, f0, fd, u)
grad=zeros(Nt,1);
f_zw=[f0;f];
fn=zeros(N,1);
gradfJ=gradfJt(alpha, beta, gamma, N, dx,dt, Nt, f, fd, u);
zeta=get_adjoint(s,D, gp, gq, lambda, jc, dt, dx, N, Nt, u, gradfJ);
    for n=0:Nt-1
        fn(1,1)=-f_zw(n*N+2,1);
        fn(2:N-1,1)=f_zw((n*N+1):((n+1)*N-2),1)-f_zw((n*N+3):((n+1)*N),1);
        fn(N,1)=f_zw((n+1)*N-1,1);
        grad(n+1,1)=-(fn')*zeta(n*N+1:(n+1)*N,1)*dx/(D*2);
    end
    grad=grad+graduJt(gamma, N, Nt, f, f0, u,dx,dt);
end

function [zeta]=get_adjoint(s,D, gp, gq, lambda, jc, dt, dx, N, Nt, u, gradfJ)
zeta=zeros(N*Nt,1);
zeta((Nt-1)*N+1:Nt*N)=-gradfJ((Nt-1)*N+1:Nt*N,1);
    for n=(Nt-1):-1:1
        P=get_P(s,D, gp, gq, lambda, jc, dx, dt, N, u(n+1));
        zeta((n-1)*N+1:n*N)=-gradfJ((n-1)*N+1:n*N)+P'*zeta(n*N+1:(n+1)*N);
    end  
end

function [g]=gradfJt(alpha, beta, gamma, N, dx,dt, Nt, f, fd, u)
g=alpha*dx*dt*[f(1:(N*(Nt-1)))-fd(1:(N*(Nt-1)));zeros(N,1)]+beta*dx*[zeros((Nt-1)*N,1);f((N*(Nt-1)+1):(N*Nt))-fd((N*(Nt-1)+1):(N*Nt))]+(gamma/2)*dx*dt*[kron(u(2:Nt,1).^2,ones(N,1));zeros(N,1)];
end

function [g]=graduJt(gamma, N, Nt, f, f0, u,dx,dt)
g(1,1)=u(1)*sum(f0);   
for n=2:Nt
        g(n,1)=sum(f((n-2)*N+1:(n-1)*N))*u(n);
end
   g=gamma*dx*dt*g;
end


function [J]=get_Jt(alpha, beta, gamma, N, Nt, f, fd,f0, u,dt,dx)
f_zw_u=[f0;f];
sum_cost=0;
for n=1:Nt
    sum_cost=sum_cost+(u(n)^2)*sum(f_zw_u((n-1)*N+1:n*N));
end
f_zw=(f-fd).^2;
J=dx*dt*(alpha/2)*sum(f_zw(1:(Nt-1)*N)) + dx*(beta/2)*sum(f_zw((Nt-1)*N+1:Nt*N)) + dx*dt*(gamma/2)*sum_cost;
end

function [f]=get_f(f0, s,D, gp, gq, lambda, jc, dx, dt, N, Nt, u)
f=zeros(Nt*N,1);
f_zw=f0;
    for n=1:Nt
        f_zw=get_P(s,D, gp, gq, lambda, jc, dx, dt, N, u(n))*f_zw;
        f((n-1)*N+1:n*N,1)=f_zw;
    end
end

function [gp,gq,g0]=get_g(dx,l)
g0=0;
x=0;
i=0;
while (x<=l-dx)
    x=x+dx;
    i=i+1;
    gp(i)=10;
    gq(i)=10;
end
end

function [P]=get_P(s,D, gp, gq, lambda, jc, dx, dt, N, u)
r=1-s;
np=max(size(gp));
nq=max(size(gq));
for i=1:np
    r=r-dt*dx*lambda*gp(i);
end
for i=1:nq
    r=r-dt*dx*lambda*gq(i);
end
TransMat=spdiags(r*ones(N,1),0,N,N);
for i=1:nq
    TransMat=TransMat+spdiags(dt*dx*lambda*gq(i)*ones(N,1),i,N,N);
end
for i=1:np
    TransMat=TransMat+spdiags([dt*dx*lambda*gp(i)*ones(N,1)],-i,N,N);
end
TransMat=TransMat+spdiags([[0.5*s*ones(N,1)] [0.5*s*ones(N,1)]],[-1,1],N,N);
U=(dx/(2*D))*spdiags([u*ones(N,1), -u*ones(N)],[-1,1],N,N);

P=TransMat+U;
end

function [u]=Proj(u,s,D,dx)
u_up=min((D/dx)*s,(D/dx)*(2-s));
u_lo=max((-D/dx)*s,-(D/dx)*(2-s));
u=min(max(u_lo,u),u_up);
end

function [t]=armijo_Jt(alpha, beta, gamma, lambda, gp, gq,jc, dt, dx,s,D, N,Nt, f, f0, fd, u, grad)
sigma=0.5;
basis=0.9;
counter=0;
t=1;
%grad=gradJt(alpha, beta, gamma, p, q, gp, gq, lambda, jp, jq, dt, N, T, f, f0, fd, u);
Jt=get_Jt(alpha, beta, gamma, N, Nt, f, fd,f0, u,dt,dx);
%grad=gradJt(alpha, beta, gamma, p, q, gp, gq, lambda, jp, jq, dt, N, T, f, f0, fd, u);
ut=Proj(u-t*grad,s,D,dx);
f=get_f(f0, s,D, gp, gq, lambda, jc, dx, dt, N, Nt, ut);
Jtleft=get_Jt(alpha, beta, gamma, N, Nt, f, fd,f0, ut,dt,dx);
% if (i<20)
% pJJt(alpha, beta, gamma, p, q, gp, g0, gq, lambda, jp, jq, dt, N, T, f0, fd,u, sigma);
% end
while (Jtleft>Jt-sigma*(grad')*(u-ut))
    counter=counter+1;
    t=basis^counter;
    ut=Proj(u-t*grad,s,D,dx);
    f=get_f(f0, s,D, gp, gq, lambda, jc, dx, dt, N, Nt, ut);
    Jtleft=get_Jt(alpha, beta, gamma, N, Nt, f, fd,f0, ut,dt,dx);
    if (t < 10^-20)
    fprintf('Schrittweite unter 10^-20');
    break;
    end
end
end

function [f]=get_fd(x_initial_fd, ampl_sin_fd, N, a, b, T,Nt,dx)
f=zeros(Nt*N,1);
for n=1:Nt
    x_quer=x_initial_fd+ampl_sin_fd*sin(4*2*pi*n/(4*Nt));
    counter=0;
    for x=a+dx:dx:b-dx
        counter=counter+1;
        if (x_quer-0.1<=x && x<=x_quer+0.1)
            f((n-1)*N+counter)=5;
        end
    end
end
end

function [f]=get_fd_test(N,Nt)
f=zeros(Nt*N,1);
% for n=1:Nt
%     x_quer=x_initial_fd+round(ampl_sin_fd*sin(-3*2*pi*n/(4*Nt)));
%     counter=0;
%     for x=a+dx:dx:b-dx
%         counter=counter+1;
%         if (x_quer-0.1<=x && x<=x_quer+0.1)
%             f((n-1)*N+counter)=5;
%         end
%     end
% end

end

function [f0]=get_f0(dx, N,a,b)
f0=zeros(N,1);
counter=0;
x_quer=(b+a)/2;
for x=a+dx:dx:b-dx
        counter=counter+1;
        if (x_quer-0.2<=x && x<=x_quer+0.2)
            f0(counter)=2.5;
        end
end
end

function[t]=get_WPS(alpha, beta, gamma, N, Nt, f, fd,f0,dx,dt,D,s,Maximi,Minimi,t,grad,u,d,gp, gq, lambda, jc,tol_t)
tau1=0.3;
tau2=0.4;
gamma_WPS=5.1;
found=0;
delta=0.01;
sigma=0.9;
%d_tilde
epsilon_rand=0;
J=get_Jt(alpha, beta, gamma, N, Nt, f, fd,f0,u,dt,dx);
for n=1:Nt
    if(max(u==Minimi))
        epsilon_rand=1;
        fprintf('Auf dem unterem Rand');
        break;
    end
    if(max(u==Maximi))
        epsilon_rand=1;
        fprintf('Auf dem oberen Rand');
        break;
    end
end
    if(epsilon_rand==1 && (min(Minimi<=u+(10^-6)*(d/(dt*norm(d))))==0 || min(u+(10^-6)*(d/(dt*norm(d)))<=Maximi)==0))
        d_tilde=0*d;
       % fprintf('hier\n');
    else
        d_tilde=d;
    end
%d_tilde ende

    zu2=1;
    zu3=1;
    zu4=1;
    zu5=1;
while(found==0)
    if (t<tol_t)
        fprintf('t zu klein');
        break;
    end
   % fprintf('Schleife 1\n');
   
    while(zu2==1)
       % fprintf('Schleife 2\n');
       ut=Proj(u+t*d,s,D,dx);
       fut=get_f(f0, s,D, gp, gq, lambda, jc, dx, dt, N, Nt, ut);
        if(get_Jt(alpha, beta, gamma, N, Nt, fut, fd,f0,ut,dt,dx)>(J+delta*t*dt*(d_tilde')*grad))
    %        fprintf('Test1\n');
            break;
        else
            if(gradJt(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, fut, f0, fd, ut)'*d_tilde>=sigma*grad'*d_tilde)
                found=1;
                zu2=0;
                zu3=0;
                zu4=0;
                zu5=0;
      %          fprintf('ja1\n');
                break;
            end
           t=gamma_WPS*t;
        end
        
    end
    while(zu3==1) 
      %  fprintf('Schleife 3\n');
        a=0;
        b=t;
        zu3=0;
        
    end
    while(zu4==1)
   %     fprintf('Schleife 4\n');
   if (t<tol_t)
            break;
   end
        t=0.5*(a+tau1*(b-a)+b-tau2*(b-a));
        zu4=0;
    end
    while(zu5==1)
        if (t<tol_t)
            break;
        end
        ut=Proj(u+t*d,s,D,dx);
        fut=get_f(f0, s,D, gp, gq, lambda, jc, dx, dt, N, Nt, ut);
       % fprintf('Schleife 5\n');
        if(get_Jt(alpha, beta, gamma, N, Nt, fut, fd,f0,ut,dt,dx)>(J+delta*t*dt*(d_tilde')*grad))
          %  fprintf('Test2\n');
            b=t;
            zu2=0;
            zu3=0;
            zu4=1;
            zu5=1;
            break;
        else
%             dj2=dJ(alpha,h,epsilon+t*d,A,N,vd)'*d
%             dj1=sigma*dJ(alpha,h,epsilon,A,N,vd)'*d_tilde
            if(gradJt(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, fut, f0, fd, ut)'*d_tilde>=sigma*grad'*d_tilde)
              % fprintf('Test3\n');
                found=1;
                zu2=0;
                zu3=0;
                zu4=0;
                zu5=0;
        %        fprintf('ja2\n');
                break;
            end
            a=t;
            zu2=0;
            zu3=0;
            zu4=1;
            zu5=1;
            break;
        end
    end
end

end

