%Implementation of an NCG scheme to solve a random walk with jumps optimal control problem with one
%absorbing and one reflecting boundary condition
%implemented by Tim Breitenbach

function [  ] = optRWJc(  )
counti_up=6;
for counti=6:counti_up
a=0;
b=1;
T=1;
D=1;
s=0.10;                      %s zulässig, das heißt 0<s<1-sum(g)
dt=T*(1/4)^(counti+1);
dx=sqrt(D*dt);
tol_t=10^-4;

% Int_dx=[20:10:110];
% Int_dt=[20:10:110].^2;
% dx=(b-a)/Int_dx(counti);
% dt=T/Int_dt(counti);

N=((b-a)/dx)+1
Nt=T/dt
x_initial_xd=(a+b)/2;    %für fd
ampl_sin_xd=(b-a)/2-0.35;      %für fd

Max1= (D/dx)*s;
Max2=(D/dx)*(2-s);
Maximi=min(Max1,Max2);
Min1=(-D/dx)*s;
Min2=-(D/dx)*(2-s);
Minimi=max(Min1,Min2);

f0=get_f0(dx, N,a,b);
sum_f0=dx*sum(f0)
figure
c=get_c(a, b, dx, N,Nt, x_initial_xd, ampl_sin_xd);
[X,TM]=meshgrid(a:dx:b,dt:dt:T);
mesh(X,TM,reshape(c,[N,Nt])')
xlabel('x');
ylabel('t');


Psi=0;     %Wird nicht gebraucht, da c: [0,T]->R

alpha=1;
beta=1;
gamma=0.1;
                    %für get_P
jc=0;               %Nicht gebraucht, früher in get_P
lambda=1;
[gp,gq,g0]=get_g(dx,0.1);

Transmat=get_Pg(s,D, gp, gq, lambda, jc, dx, dt, N); %Berechnen der Übergangsmatrix, die nicht von der Kontrolle u beeinflusst wird
% jc=3;
% lambda=0.05;
% g0=0;
% gq(1)=0;
% gq(2)=1;
% gq(3)=1;
% 
% gp(1)=0;
% gp(2)=1;
% gp(3)=1;

                    %end für get_P

                    
u=Proj(0*ones(Nt,1),s,D,dx);                     %initial u
f=get_f(f0, s,D, gp, gq, lambda, jc, dx, dt, N, Nt, u,Transmat);
g=gradJc(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, f, f0,c,Psi, u,Transmat);
ng0=sqrt(dt*g'*g)
Jc_c=get_Jc(alpha, beta, gamma, dx, dt, N, Nt, f, f0, c, Psi, u)
grad_Jc=g;
d=-grad_Jc;
t=10^3;
res=inf;
i=0;
while(i<30)
    i=i+1;
    %u_vergleich=Proj(u-grad_Jt,s,D,dx);
    %res=sqrt((norm(u-u_vergleich)^2)*dt);
    res=sqrt(dt*norm(g)^2)
    Jc_c=get_Jc(alpha, beta, gamma, dx, dt, N, Nt, f, f0, c, Psi, u)
    t=get_WPS(alpha, beta, gamma, N, Nt, f, c, Psi,f0,dx,dt,D,s,Maximi,Minimi,t,grad_Jc,u,d,gp, gq, lambda, jc,tol_t,Transmat)
    if (res<10^-6 || t<tol_t)
        break;
    end
    %t=0.01;
    %t=armijo_Jt(alpha, beta, gamma, lambda, gp, gq,jc, dt, dx,s,D, N,Nt, f, f0, fd, u, grad_Jt)
    u=Proj(u+t*d,s,D,dx);
    f=get_f(f0, s,D, gp, gq, lambda, jc, dx, dt, N, Nt, u,Transmat);
    g_alt=g;
    g=gradJc(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, f, f0,c,Psi, u,Transmat);
    grad_Jt=g;
    y=g-g_alt;
    sigma_HZ=y-2*d*(y')*y/(y'*d);
    beta_HZ=(sigma_HZ'*g)/(d'*y);
    d=-g+beta_HZ*d;
    %test_grad(alpha, beta, gamma, dx, dt, N, Nt,s,D, f0, fd,f,u,gp, gq, lambda, jc)
    %test_graduJ(alpha, beta, gamma, N, Nt,f0, fd,dt,dx,u)
    %test_gradfJ(alpha, beta, gamma, N,Nt,f,fd,f0,dt,dx,u)
end
dt*(gradJc(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, f, f0,c,Psi, u,Transmat)')*(0*ones(Nt,1)-u)
ng=sqrt(dt*norm(gradJc(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, f, f0,c,Psi, u,Transmat))^2)
Jc_c=get_Jc(alpha, beta, gamma, dx, dt, N, Nt, f, f0, c, Psi, u)
sum_fT=dx*sum(f(((Nt-1)*N+1):Nt*N))
figure
plot(0:dt:T-dt,u)
xlabel('t');
figure
[X,T]=meshgrid(a:dx:b,0:dt:T);
f_plot=[f0;f];
contour(X,T,reshape(f_plot,[N,Nt+1])',20);
xlabel('x');
ylabel('t');
figure
mesh (X,T,reshape(f_plot,[N,Nt+1])');
xlabel('x');
ylabel('t');
% dt_interp=(T*(1/4)^(counti_up+1));
% u_interp(1:T/dt_interp,counti)=interp1(0:dt:(T-dt),u,0:dt_interp:T-dt_interp)';
% 
% plot(0:dt_interp:T-dt_interp,u_interp(:,counti));
% xlabel('t');

end
end

function [zeta]=get_adjoint(s,D, gp, gq, lambda, jc, dt, dx, N, Nt, u, gradfJ,Transmat)
zeta=zeros(N*Nt,1);
zeta((Nt-1)*N+1:Nt*N)=-gradfJ((Nt-1)*N+1:Nt*N,1);
    for n=(Nt-1):-1:1
        P=get_PR(s,D, gp, gq, lambda, jc, dx, dt, N, u(n+1),Transmat);
        zeta((n-1)*N+1:n*N)=-gradfJ((n-1)*N+1:n*N)+P'*zeta(n*N+1:(n+1)*N);
    end  
end

function [f]=get_f(f0, s,D, gp, gq, lambda, jc, dx, dt, N, Nt, u,Transmat)
f=zeros(Nt*N,1);
f_zw=f0;
    for n=1:Nt
        f_zw=get_PR(s,D, gp, gq, lambda, jc, dx, dt, N, u(n),Transmat)*f_zw;
        f((n-1)*N+1:n*N,1)=f_zw;
    end
end

function [gp,gq,g0]=get_g(dx,l)
g0=0;
x=0;
i=0;
while (x<=l-dx)
    x=x+dx;
    i=i+1;
    gp(i)=10;
    gq(i)=10;
end
end

% function [P]=get_P(s,D, gp, gq, lambda, jc, dx, dt, N, u)
% r=1-s;
% np=max(size(gp));
% nq=max(size(gq));
% for i=1:np
%     r=r-dt*dx*lambda*gp(i);
% end
% for i=1:nq
%     r=r-dt*dx*lambda*gq(i);
% end
% TransMat=spdiags(r*ones(N,1),0,N,N);
% for i=1:nq
%     TransMat=TransMat+spdiags(dt*dx*lambda*gq(i)*ones(N,1),i,N,N);
% end
% for i=1:np
%     TransMat=TransMat+spdiags([dt*dx*lambda*gp(i)*ones(N,1)],-i,N,N);
% end
% TransMat=TransMat+spdiags([[0.5*s*ones(N,1)] [0.5*s*ones(N,1)]],[-1,1],N,N);
% U=(dx/(2*D))*spdiags([u*ones(N,1), -u*ones(N)],[-1,1],N,N);
% 
% P=TransMat+U;
% end

function [P]=get_PR(s,D, gp, gq, lambda, jc, dx, dt, N, u, Transmat)


U=(dx/(2*D))*spdiags([u*ones(N,1), -u*ones(N)],[-1,1],N,N);

P=Transmat+U;

%Reflections by RW
P(2,1)=P(2,1)+0.5*(s-dx*u/D);
P(N-1,N)=P(N-1,N)+0.5*(s+dx*u/D);

end

function[P]=get_Pg(s,D, gp, gq, lambda, jc, dx, dt, N)
P=sparse(zeros(N,N));
P=P+spdiags([[0.5*s*ones(N,1)] [0.5*s*ones(N,1)]],[-1,1],N,N);
r=1-s;
np=max(size(gp));
nq=max(size(gq));
for i=1:np
    r=r-dt*dx*lambda*gp(i);
end
for i=1:nq
    r=r-dt*dx*lambda*gq(i);
end
P=P+spdiags(r*ones(N,1),0,N,N);
for i=1:nq
    P=P+spdiags(dt*dx*lambda*gq(i)*ones(N,1),i,N,N);
end
for i=1:np
    P=P+spdiags([dt*dx*lambda*gp(i)*ones(N,1)],-i,N,N);
end


%g erweitern mit 0en

for i=(np+1):(2*(N-1))
    gp(i)=0;
end
for i=(nq+1):(2*(N-1))
    gq(i)=0;
end


%Reflections by jumps
P(1,N)=P(1,N)+lambda*dt*dx*gp(N-1); %Erste Zeile
P(N,1)=P(N,1)+lambda*dt*dx*gq(N-1); %letzte Zeile

%Zweite Zeile
P(2,:)=P(2,:)+lambda*dx*dt*(gq(1:1:((N-1)+1))+gp((2*(N-1)-1):-1:((N-1)-1)));

%Vorletzte Zeile
P(N-1,:)=P(N-1,:)+lambda*dt*dx*(gq(((N-1)-1):1:(2*(N-1)-1))+gp(N-1+1:-1:1));

%Mittelteil
for j=3:N-2
    P(j,:)=P(j,:)+lambda*dt*dx*(gq((j-1):1:((j-1)+(N-1)))+gp((2*(N-1)-(j-1)):-1:(2*(N-1)-(j-1)-(N-1))));
end


end

function [u]=Proj(u,s,D,dx)
u_up=min((D/dx)*s,(D/dx)*(2-s));
u_lo=max((-D/dx)*s,-(D/dx)*(2-s));
u=min(max(u_lo,u),u_up);
end

function [J]=get_Jc(alpha, beta, gamma, dx, dt, N, Nt, f, f0, c, Psi, u)
f_zw_u=[f0;f];
sum_cost=0;
for n=1:Nt
    sum_cost=sum_cost+(u(n)^2)*sum(f_zw_u((n-1)*N+1:n*N));
end
%Psi=[zeros((T-1)*N,1);Psi];
J=alpha*dx*dt*sum(f(1:(Nt-1)*N).*c(1:(Nt-1)*N)) + beta*dx*sum(f((Nt-1)*N+1:Nt*N).*c((Nt-1)*N+1:Nt*N)) + (gamma/2)*dx*dt*sum_cost;
end

function [x]=get_xd(x_initial_xd, ampl_sin_xd, Nt)
x=zeros(Nt,1);
for n=1:Nt
   x(n)=x_initial_xd + ampl_sin_xd*sin(2*pi*n/Nt);
end
end

% function [f]=get_c(a, b, dx, N, Nt, x_initial_xd, ampl_sin_xd)
% f=zeros(N*Nt,1);
% xd=get_xd(x_initial_xd, ampl_sin_xd, Nt);
%     for n=1:Nt
%         f((n-1)*N+1:n*N)=10*(((a:dx:b)'-xd(n)).*((a:dx:b)'-xd(n))).^1-0;
%     end
% end

function [f]=get_c(a,b,dx,N,Nt,x_initial_xd,ampl_sin_xd)
f=100*ones(N*Nt,1);
xd=get_xd(x_initial_xd, ampl_sin_xd, Nt);
    for n=1:Nt
        i=0;
        for x=a:dx:b
            i=i+1;
            if(xd(n)-0.1<=x && x<=xd(n)+0.1)
                 f((n-1)*N+i,1)=0;
            end
        end
    end
end


function [f0]=get_f0(dx, N,a,b)
f0=zeros(N,1);
counter=0;
x_quer=(b+a)/2;
for x=a+dx:dx:b-dx
        counter=counter+1;
        if (x_quer-0.2<=x && x<=x_quer+0.2)
            f0(counter)=2.5;
        end
end
f0=f0/(dx*sum(f0));
end

function [g]=gradfJc(alpha, beta, gamma,dx,dt, N, Nt, c, Psi, u)
g=alpha*dx*dt*[c(1:(Nt-1)*N);zeros(N,1)] + beta*dx*[zeros((Nt-1)*N,1);c((Nt-1)*N+1:Nt*N)] + (gamma/2)*dx*dt*[kron(u(2:Nt,1).^2,ones(N,1));zeros(N,1)];
end

function [g]=graduJc(gamma, N, Nt, f, f0, u,dx,dt)
  g(1,1)=u(1)*sum(f0);   
for n=2:Nt
        g(n,1)=sum(f((n-2)*N+1:(n-1)*N))*u(n);
end
   g=gamma*dx*dt*g;
end

function [grad]=gradJc(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, f, f0,c,Psi, u,Transmat)
grad=zeros(Nt,1);
f_zw=[f0;f];
fn=zeros(N,1);
gradfJ=gradfJc(alpha, beta, gamma,dx,dt, N, Nt, c, Psi, u);
zeta=get_adjoint(s,D, gp, gq, lambda, jc, dt, dx, N, Nt, u, gradfJ,Transmat);
    for n=0:Nt-1
        fn(1,1)=-f_zw(n*N+2,1);
        fn(2:N-1,1)=f_zw((n*N+1):((n+1)*N-2),1)-f_zw((n*N+3):((n+1)*N),1);
        fn(N,1)=f_zw((n+1)*N-1,1);
        grad(n+1,1)=-(fn')*zeta(n*N+1:(n+1)*N,1)*dx/(D*2);
    end
    grad=grad+graduJc(gamma, N, Nt, f, f0, u,dx,dt);
end

function[t]=get_WPS(alpha, beta, gamma, N, Nt, f, c, Psi,f0,dx,dt,D,s,Maximi,Minimi,t,grad,u,d,gp, gq, lambda, jc,tol_t,Transmat)
tau1=0.3;
tau2=0.4;
gamma_WPS=5.1;
found=0;
delta=0.001;
sigma=0.9;
%d_tilde
epsilon_rand=0;
J=get_Jc(alpha, beta, gamma, dx, dt, N, Nt, f, f0, c, Psi, u);
for n=1:Nt
    if(max(u==Minimi))
        epsilon_rand=1;
        fprintf('Auf dem unterem Rand');
        break;
    end
    if(max(u==Maximi))
        epsilon_rand=1;
        fprintf('Auf dem oberen Rand');
        break;
    end
end
    if(epsilon_rand==1 && (min(Minimi<=u+(10^-6)*(d/(dt*norm(d))))==0 || min(u+(10^-6)*(d/(dt*norm(d)))<=Maximi)==0))
        d_tilde=0*d;
       % fprintf('hier\n');
    else
        d_tilde=d;
    end
%d_tilde ende

    zu2=1;
    zu3=1;
    zu4=1;
    zu5=1;
while(found==0)
    if (t<tol_t)
        fprintf('t zu klein');
        break;
    end
   % fprintf('Schleife 1\n');
   
    while(zu2==1)
       % fprintf('Schleife 2\n');
       ut=Proj(u+t*d,s,D,dx);
       fut=get_f(f0, s,D, gp, gq, lambda, jc, dx, dt, N, Nt, ut,Transmat);
        if(get_Jc(alpha, beta, gamma, dx, dt, N, Nt, fut, f0, c, Psi, ut)>(J+delta*t*dt*(d_tilde')*grad))
    %        fprintf('Test1\n');
            break;
        else
            if(gradJc(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, fut, f0,c,Psi, ut,Transmat)'*d_tilde>=sigma*grad'*d_tilde)
                found=1;
                zu2=0;
                zu3=0;
                zu4=0;
                zu5=0;
      %          fprintf('ja1\n');
                break;
            end
           t=gamma_WPS*t;
        end
        
    end
    while(zu3==1) 
      %  fprintf('Schleife 3\n');
        a=0;
        b=t;
        zu3=0;
        
    end
    while(zu4==1)
   %     fprintf('Schleife 4\n');
   if (t<tol_t)
            break;
   end
        t=0.5*(a+tau1*(b-a)+b-tau2*(b-a));
        zu4=0;
    end
    while(zu5==1)
        if (t<tol_t)
            break;
        end
        ut=Proj(u+t*d,s,D,dx);
        fut=get_f(f0, s,D, gp, gq, lambda, jc, dx, dt, N, Nt, ut,Transmat);
       % fprintf('Schleife 5\n');
        if(get_Jc(alpha, beta, gamma, dx, dt, N, Nt, fut, f0, c, Psi, ut)>(J+delta*t*dt*(d_tilde')*grad))
          %  fprintf('Test2\n');
            b=t;
            zu2=0;
            zu3=0;
            zu4=1;
            zu5=1;
            break;
        else
%             dj2=dJ(alpha,h,epsilon+t*d,A,N,vd)'*d
%             dj1=sigma*dJ(alpha,h,epsilon,A,N,vd)'*d_tilde
            if(gradJc(alpha, beta, gamma, s,D, gp, gq, lambda, jc, dt, dx, N, Nt, fut, f0,c,Psi, ut,Transmat)'*d_tilde>=sigma*grad'*d_tilde)
              % fprintf('Test3\n');
                found=1;
                zu2=0;
                zu3=0;
                zu4=0;
                zu5=0;
        %        fprintf('ja2\n');
                break;
            end
            a=t;
            zu2=0;
            zu3=0;
            zu4=1;
            zu5=1;
            break;
        end
    end
end

end
