%Numerical PMP test
function [maxDiff,ratio] = check_u_opt( u,y0,f,yd,OCP )
y=implForward(u,y0,f,OCP);
p=implBackward(y,yd,OCP);

for j=1:OCP.Nt
         for i=1:OCP.N-1 
             %Calculation of the value of the Hamiltonian with the results
             %from the SQH method
             ufk=u((j-1)*(OCP.N-1)+i,1);
             Hu((j-1)*(OCP.N-1)+i)=(OCP.alpha/2)*ufk.^2+OCP.beta*(abs(ufk)*(abs(ufk)>OCP.s))+ufk.*p((j-1)*(OCP.N+1)+1+i);
             posi=(j-1)*(OCP.N+1)+1+i;
             Hu((j-1)*(OCP.N-1)+i)=0.5*OCP.alpha*(ufk.*ufk)+OCP.beta*sqrt(abs(ufk))+p(posi)*(ufk+f(posi));
             Hu((j-1)*(OCP.N-1)+i)=(OCP.alpha/2)*ufk.^2+OCP.beta*(1*(abs(ufk)>OCP.s)+2.5*(abs(ufk)>2*OCP.s))+(ufk+f(posi)).*p(posi);
         end
end


for j=1:OCP.Nt
    for i=1:OCP.N-1
    %Calculation of the value where the Hamiltonian takes its minimum for
    %given y and p from the SQH method
    uint=u((j-1)*(OCP.N-1)+i,1);
    u_new((j-1)*(OCP.N-1)+i,1)=argminH(i,j,p,uint,0,f,OCP ); %epsilon=0 to obtain the Hamiltonian from the augmented Hamiltonian. Thus uint is not needed.
    end
end


for j=1:OCP.Nt
         for i=1:OCP.N-1 
             %Calculation of the corresponding values of the Hamiltonian
             %for y,p and u_new
             ufk=u_new((j-1)*(OCP.N-1)+i,1);
             Hw((j-1)*(OCP.N-1)+i)=(OCP.alpha/2)*ufk.^2+OCP.beta*(abs(ufk)*(abs(ufk)>OCP.s))+ufk.*p((j-1)*(OCP.N+1)+1+i);
             posi=(j-1)*(OCP.N+1)+1+i;
             Hw((j-1)*(OCP.N-1)+i)=0.5*OCP.alpha*(ufk.*ufk)+OCP.beta*sqrt(abs(ufk))+p(posi)*(ufk+f(posi));
             Hw((j-1)*(OCP.N-1)+i)=(OCP.alpha/2)*ufk.^2+OCP.beta*(1*(abs(ufk)>OCP.s)+2.5*(abs(ufk)>2*OCP.s))+(ufk+f(posi)).*p(posi);
         end
end

maxDiff=max(Hu-Hw);
fprintf('\n');
fprintf('Max: %d\n',maxDiff);
for l=2:2:12
count=0;
for j=1:OCP.Nt
    for i=1:OCP.N-1
        if(Hu((j-1)*(OCP.N-1)+i)-Hw((j-1)*(OCP.N-1)+i)<10^(-l))
            count=count+1;
        end
    end
end

ratio=count/(OCP.Nt*(OCP.N-1));
fprintf('10^-%i: %f\t',l,ratio);
end
fprintf('\n');

end

