%Numerical PMP test where the Hamiltonain is minimized by exact formulas

function [] = optimal_exact(v,w,fin,cd,OCP)

f=fok_pl(v,w,fin,1,OCP);
p=adj_fok_pl(v,w,cd,1,OCP);
Nt=OCP.T/OCP.dt;
dx=OCP.dx;
N=((OCP.b-OCP.a)/OCP.dx)-1;
sv=OCP.sv;
sw=OCP.sw;
epsi=0;


for i=1:Nt
       fzw=f(:,:,i);
       a=sum(sum(fzw))*dx*dx;
       dp_x1=(p(3:N+2,:,i)-p(1:N,:,i))/(2*dx);
       dp_x2=(p(:,3:N+2,i)-p(:,1:N,i))/(2*dx);
       b1=sum(sum(dp_x1.*fzw(2:N+1,:)))*dx*dx;
       b2=sum(sum(dp_x2.*fzw(:,2:N+1)))*dx*dx;
       c1=sum(sum((dp_x1.*fzw(2:N+1,:)).*((ones(N+2,1)*(OCP.a+(1:N)*dx)))'))*dx*dx;
       c2=sum(sum((dp_x2.*fzw(:,2:N+1)).*((ones(N+2,1)*(OCP.a+(1:N)*dx)))))*dx*dx;
       Hopt(i)=a*(OCP.alpha*(max(abs(v(1,i))-OCP.sv,0)+max(abs(v(2,i))-OCP.sv,0)) + ...
            OCP.beta*(max(abs(w(1,i))-OCP.sw,0)+max(abs(w(2,i))-OCP.sw,0)))...
           +b1*v(1,i)+c1*w(1,i)+b2*v(2,i)+c2*w(2,i);
           
end

for i=1:Nt
       fzw=f(:,:,i);
       a=sum(sum(fzw))*dx*dx;
       dp_x1=(p(3:N+2,:,i)-p(1:N,:,i))/(2*dx);
       dp_x2=(p(:,3:N+2,i)-p(:,1:N,i))/(2*dx);
       b1=sum(sum(dp_x1.*fzw(2:N+1,:)))*dx*dx;
       b2=sum(sum(dp_x2.*fzw(:,2:N+1)))*dx*dx;
       c1=sum(sum((dp_x1.*fzw(2:N+1,:)).*((ones(N+2,1)*(OCP.a+(1:N)*dx)))'))*dx*dx;
       c2=sum(sum((dp_x2.*fzw(:,2:N+1)).*((ones(N+2,1)*(OCP.a+(1:N)*dx)))))*dx*dx;
       
v11=OCP.vmin;
       v12=-sv;
       v13=0;
       v14=sv;
       v15=OCP.vmax;
       
       v21=OCP.vmin;
       v22=-sv;
       v23=0;
       v24=sv;
       v25=OCP.vmax;
       
       
       w11=OCP.wmin;
       w12=-sw;
       w13=0;
       w14=sw;
       w15=OCP.wmax;
       
       w21=OCP.wmin;
       w22=-sw;
       w23=0;
       w24=sw;
       w25=OCP.wmax;
       
       
       VecVal=combvec([v11 v12 v13 v14 v15],[v21 v22 v23 v24 v25], [w11 w12 w13 w14 w15], [w21 w22 w23 w24 w25])';
       

       H1=a*(OCP.alpha*(max(abs(VecVal(:,1))-OCP.sv,0)+max(abs(VecVal(:,2))-OCP.sv,0)) + ...
            OCP.beta*(max(abs(VecVal(:,3))-OCP.sw,0)+max(abs(VecVal(:,4))-OCP.sw,0)))...
           +b1*VecVal(:,1)+c1*VecVal(:,3)+b2*VecVal(:,2)+c2*VecVal(:,4)...
           +epsi*( ((VecVal(:,1)-v(1,i)).^2) + ((VecVal(:,3)-w(1,i)).^2) + ((VecVal(:,2)-v(2,i)).^2) + (VecVal(:,4)-w(2,i)).^2);
       
        [Hnew(i),pos]=min(H1);
        v(1,i)=VecVal(pos,1);
        v(2,i)=VecVal(pos,2);
        w(1,i)=VecVal(pos,3);
        w(2,i)=VecVal(pos,4);
end


fprintf('Max DH: %d\n',max(Hopt-Hnew));
fprintf('Min DH: %d\n',min(Hopt-Hnew));
fprintf('Fraction of grid points where 0<=DH<=10^-l is fulfilled:\n')
for l=1:12
count=0;
for i=1:Nt
         %Count the numer of grid points where the solution u is PMP optimal up to the tolerance 10^-l
            if (Hopt(i)-Hnew(i)<=10^-l)
                count=count+1;
            end
end

ratio=count/Nt;
fprintf('l=%i: %f\t',l,ratio);
end
fprintf('\n');

end

