%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Main function;
function plotting
close all;

% PLOT L1 CONTROLS!!
% Load the result-file;
load('Test2GL-bet1e-1.mat');
u_all1 = u_all;
load('Test2GL-bet3e0.mat');
u_all2 = u_all;
load('Test2GL-bet6e0.mat');
u_all3 = u_all;

% Extract the number of solutions (number of continuation steps
% or numbers of n);
Num = size(ni_all,1);
% Extract the number of controls;
NC = size(ni_all,3);


hFig = figure(1);
set(hFig, 'Position', [100 20 1100 1000]);
for k = 1 : Num
    subplot(Num/2,2,k);
    hold on;
    for n = 1 : NC
        p1=plot(time_vec./time_vec(end),u_all1(k,:,n)./100,'k:','LineWidth',2.1);
        p2=plot(time_vec./time_vec(end),u_all2(k,:,n)./100,'k--','LineWidth',2.0);
        p3=plot(time_vec./time_vec(end),u_all3(k,:,n)./100,'k-','LineWidth',1.8);
    end
    %set(gca,'xticklabel',[])
    xlabel('t/T','interpreter','latex','FontSize',14);
    %set(gca,'yticklabel',[])
    ylabel('u/100','interpreter','latex','FontSize',14);
    axis([0 1 -1 1 ]);
    grid on;
    set(gca,'FontSize',13);
    str1 = '$$\nu$$=';
    formatSpec = '%10.4e\n';
    str2 = num2str(ni_all(k),formatSpec);
    str = strcat(str1,str2);
    text(0.04,0.85,str,'interpreter','latex','FontSize',15,'FontWeight','bold');
    % Create a legend common for all the plots;
    hL = legend([p1,p2,p3],{'$$\beta$$=0.1','$$\beta$$=3.0','$$\beta$$=6.0'},'interpreter','latex','FontSize',15,'FontWeight','bold');
    % Programatically move the Legend
    newPosition = [0.13 0.965 0.775 0.01];
    newUnits = 'normalized';
    set(hL,'Orientation','horizontal','Position', newPosition,'Units', newUnits);
    hold off;
end


u_allall=zeros(size(u_all1,2),8);
bet = [ 0.1 1 2 3 4 5 6 7 ];
% Load the result-file;
load('Test2GL-bet1e0.mat');
u_allall(:,1) = u_all(end,:,1);
load('Test2GL-bet2e0.mat');
u_allall(:,2) = u_all(end,:,1);
load('Test2GL-bet3e0.mat');
u_allall(:,3) = u_all(end,:,1);
load('Test2GL-bet4e0.mat');
u_allall(:,4) = u_all(end,:,1);
load('Test2GL-bet5e0.mat');
u_allall(:,5) = u_all(end,:,1);
load('Test2GL-bet6e0.mat');
u_allall(:,6) = u_all(end,:,1);
load('Test2GL-bet7e0.mat');
u_allall(:,7) = u_all(end,:,1);
hFig=figure(2);
set(hFig, 'Position', [100 20 1100 1000]);
for k = 1 : 8
    subplot(4,2,k);
    hold on;
    for n = 1 : NC
        plot(time_vec./time_vec(end),u_allall(:,k)./100,'k-','LineWidth',2.0);
    end
    %set(gca,'xticklabel',[])
    xlabel('t/T','interpreter','latex','FontSize',14);
    %set(gca,'yticklabel',[])
    ylabel('u/100','interpreter','latex','FontSize',14);
    axis([0 1 -1 1 ]);
    grid on;
    set(gca,'FontSize',13);
    str1 = '$$\beta$$=';
    formatSpec = '%10.4e\n';
    str2 = num2str(bet(k),formatSpec);
    str = strcat(str1,str2);
    text(0.04,0.85,str,'interpreter','latex','FontSize',15,'FontWeight','bold');
end